using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using MbUnit.Framework;
using WindowsLive.Writer.Api;

namespace LiveWriterOptions.Tests
{
[TestFixture]
public class Tests
{
    [Test]
    public void ContentCreatedAsExpected()
    {
        OptionsPlugin op = new OptionsPlugin();
        op.Initialize(new PropertiesStub());
        string actualContent = string.Empty;
        DialogResult actualResult = op.CreateContent(null, ref actualContent);
        Assert.AreEqual(actualResult, DialogResult.OK);
        Assert.AreEqual(actualContent, "Option not set");
    }
}

public class PropertiesStub : IProperties
{
    Dictionary<string, string> h = new Dictionary<string, string>();
    public string GetString(string name, string defaultValue)
    {
        if (h.ContainsKey(name))
            return h[name];
        else
            return defaultValue;
    }

    public void SetString(string name, string value)
    {
        if (h.ContainsKey(name))
            h[name] = value;
        else
            h.Add(name, value);
    }

        #region IProperties Members

        public bool Contains(string name)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public bool ContainsSubProperties(string name)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public bool GetBoolean(string name, bool defaultValue)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public decimal GetDecimal(string name, decimal defaultValue)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public float GetFloat(string name, float defaultValue)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public int GetInt(string name, int defaultValue)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        

        public IProperties GetSubProperties(string name)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public string[] Names
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        public void Remove(string name)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public void RemoveAll()
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public void RemoveSubProperties(string name)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public void SetBoolean(string name, bool value)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public void SetDecimal(string name, decimal value)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public void SetFloat(string name, float value)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public void SetInt(string name, int value)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        

        public string[] SubPropertyNames
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        public string this[string name]
        {
            get
            {
                throw new Exception("The method or operation is not implemented.");
            }
            set
            {
                throw new Exception("The method or operation is not implemented.");
            }
        }

        #endregion
    }
}
